#include <stdio.h>
#include <stdlib.h>

typedef unsigned char byte;

void dump(byte *buf, int n)
{
    int i;

    for (i = 0; i < n; i++) {
        printf("%02x ", buf[i]);
        if ((i & 15) == 15)
            printf("\n");
    }
    printf("\n");
}

int main(int argc, char *argv[])
{
    int i = 0, n;
    FILE *hnd = fopen(argv[1], "rb");
    FILE *out = fopen("dec.img", "wb");
    byte buf[0x2000];
    int idx, last = -1;

    n = fread(buf, 1, 9, hnd);

    printf("Header\n");
    dump(buf, n);

    for (;;) {
        printf("At %lx\n", ftell(hnd));

        n = fread(buf, 1, 8, hnd);

        if (0x60 == buf[2]) {
            printf("Erase\n");
            dump(buf, 6);

            fseek(hnd, -2, SEEK_CUR);
            n = fread(buf, 1, 8, hnd);
        }

        idx = *(unsigned*)(buf+4);

        printf("Command %x\n", idx);
        dump(buf, n);

        if (0x80 != buf[2])
            break;

        if (-1 != last && idx != last + 0x100)
            printf("Index %x -> %x\n", last, idx);

        last = idx;

        if (feof(hnd))
            break;

        fseek(out, idx * 0x20, SEEK_SET);
        n = fread(buf, 1, 0x2000, hnd);
        fwrite(buf, 1, n, out);

        printf("Data (%d)\n", n);
        dump(buf, 16);
        printf("...\n");
        dump(buf+n-16, 16);

        if (feof(hnd))
            break;
    }

    fclose(out);
    fclose(hnd);

    return 0;
}

