%plt = (
 "2430" => "ioctl",
 "2444" => "printf",
 "2458" => "memcpy",
 "246c" => "puts",
 "2480" => "malloc",
 "2494" => "mmap",
 "24a8" => "write",
 "24bc" => "fstat",
 "24d0" => "read",
 "24e4" => "memset",
 "24f8" => "exit",
 "250c" => "_libc_start_main",
 "2520" => "strlen",
 "2534" => "open",
 "2548" => "close",
);

%sym = (
 "255c" => "main",
 "2994" => "decode_hex",
);

%not = ("e" => "ne", "ne" => "e", "ge" => "l", "g" => "le", "be" => "a", "b" => "ae", "a" => "be");

print "bits 32\n";
print "extern $imp\n" while ($addr, $imp) = each %plt;
print "global $s\n" while ($addr, $s) = each %sym;
print "%define _r0 0\n";
print "%define _r1 esp\n";
print "%define _r$_ [__r$_]\n" for (2..32);
print "section .text\n";
print "L_0:\n";

sub ldaddr {
    my ($r, $haddr) = @_;
    my $a = hex($haddr);
    if ($a > 0x3400 && $a < 0x3800) {
        return "lea eax, [(strings + $a - 3400h)]\nmov _$r, eax\n";
    } else {
        return "mov word _$r, 0${haddr}h\n";
    }
}

sub call {
    my $f = shift;
    return "push dword _r5\npush dword _r4\npush dword _r3\ncall $f\nadd esp, 12\n";
}

while (<>) {
    s/\t/ /;
    s/ <.*>$//;
    next unless /^    (.{4}): .. .. .. .. (.*)/;
    $addr = $1;
    $insn = $2;
    print "\n;$addr $insn\n\n";
    print "L_$addr:\n";
    if (exists $sym{$addr}) { print "$sym{$addr}:\n" }
    $branch = undef;
    if ($insn =~ /l.movhi (r\d+),0x(.+)/) { print "mov word [__$1+2], 0$2h\n" }
    elsif ($insn =~ /l.ori (r\d+),\1,0x(.+)/) { print ldaddr($1, $2) }
    elsif ($insn =~ /l.ori (r\d+),(r\d+),0x0/) { print "mov eax, _$2\nmov _$1, eax\n" }
    elsif ($insn =~ /l.sw (-?\d+)\(r1\),(r\d+)/) { print "mov eax, _$2\nmov [esp+($1)], eax\n" }
    elsif ($insn =~ /l.sw (-?\d+)\((r\d+)\),(r\d+)/) { print "mov eax, _$2\nmov ecx, _$3\nmov [eax+($1)], ecx\n" }
    elsif ($insn =~ /l.sfeqi (r\d+),(.+)/) { print "mov ebx, _$1\n"; $cond = "e"; $cmp = "cmp ebx, $2" }
    elsif ($insn =~ /l.sfnei (r\d+),(.+)/) { print "mov ebx, _$1\n"; $cond = "ne"; $cmp = "cmp ebx, $2" }
    elsif ($insn =~ /l.sfgesi (r\d+),(.+)/) { print "mov ebx, _$1\n"; $cond = "ge"; $cmp = "cmp ebx, $2" }
    elsif ($insn =~ /l.sfgtsi (r\d+),(.+)/) { print "mov ebx, _$1\n"; $cond = "g"; $cmp = "cmp ebx, $2" }
    elsif ($insn =~ /l.sfleui (r\d+),(.+)/) { print "mov ebx, _$1\n"; $cond = "be"; $cmp = "cmp ebx, $2" }
    elsif ($insn =~ /l.sfgtui (r\d+),(.+)/) { print "mov ebx, _$1\n"; $cond = "a"; $cmp = "cmp ebx, $2" }
    elsif ($insn =~ /l.sfne (r\d+),(r\d+)/) { print "mov ebx, _$1\nmov edx, _$2"; $cond = "ne"; $cmp = "cmp ebx, edx" }
    elsif ($insn =~ /l.sfltu (r\d+),(r\d+)/) { print "mov ebx, _$1\nmov edx, _$2"; $cond = "b"; $cmp = "cmp ebx, edx" }
    elsif ($insn =~ /l.addi r1,r1,(-?.+)/) { print "add esp, $1\n" }
    elsif ($insn =~ /l.addi (r\d+),(r\d+),(-?.+)/) { print "mov eax, _$2\nadd eax, $3\nmov _$1, eax\n" }
    elsif ($insn =~ /l.add (r\d+),(r\d+),(r\d+)/) { print "mov eax, _$2\nadd eax, _$3\nmov _$1, eax\n" }
    elsif ($insn =~ /l.or (r\d+),(r\d+),(r\d+)/) { print "mov eax, _$2\nor eax, _$3\nmov _$1, eax\n" }
    elsif ($insn =~ /l.and (r\d+),(r\d+),(r\d+)/) { print "mov eax, _$2\nand eax, _$3\nmov _$1, eax\n" }
    elsif ($insn =~ /l.andi (r\d+),(r\d+),0x(.+)/) { print "mov eax, _$2\nand eax, 0$3h\nmov _$1, eax\n" }
    elsif ($insn =~ /l.xor (r\d+),(r\d+),(r\d+)/) { print "mov eax, _$2\nxor eax, _$3\nmov _$1, eax\n" }
    elsif ($insn =~ /l.sub (r\d+),(r\d+),(r\d+)/) { print "mov eax, _$2\nsub eax, _$3\nmov _$1, eax\n" }
    elsif ($insn =~ /l.srai (r\d+),\1,0x(.+)/) { print "sar dword _$1, 0$2h\n" }
    elsif ($insn =~ /l.srli (r\d+),(r\d+),0x(.+)/) { print "mov eax, _$2\nshr eax, 0$3h\nmov _$1, eax\n" }
    elsif ($insn =~ /l.slli (r\d+),(r\d+),0x(.+)/) { print "mov eax, _$2\nshl eax, 0$3h\nmov _$1, eax\n" }
    elsif ($insn =~ /l.bf (.*)/) { $branch = "$cmp\nj$cond L_$1\n" }
    elsif ($insn =~ /l.bnf (.*)/) { $branch = "$cmp\nj$not{$cond} L_$1\n" }
    elsif ($insn =~ /l.lwz (r\d+),(-?.+)\(r1\)/) { print "mov eax, [esp+($2)]\nmov _$1, eax\n" }
    elsif ($insn =~ /l.lwz (r\d+),(-?.+)\((r\d+)\)/) { print "mov eax, _$3\nmov eax, [eax+($2)]\nmov _$1, eax\n" }
    elsif ($insn =~ /l.lbz (r\d+),(-?.+)\((r\d+)\)/) { print "mov eax, _$3\nmovzx eax, byte [eax+($2)]\nmov _$1, eax\n" }
    elsif ($insn =~ /l.sb (-?.+)\((r\d+)\),(r\d+)/) { print "mov al, _$3\nmov ecx, _$2\nmov [ecx+($1)], al\n" }
    elsif ($insn =~ /l.sh (-?.+)\((r\d+)\),(r\d+)/) { print "mov ax, _$3\nmov ecx, _$2\nmov [ecx+($1)], ax\n" }
    elsif ($insn =~ /l.jal (.*)/) { if (exists $plt{$1}) { $f = $plt{$1} } else { $f = "L_$1" } $branch = call($f) }
    elsif ($insn =~ /l.jalr (r\d+)/) { $branch = "call dword _$1\n" }
    elsif ($insn =~ /l.jr r9/) { $branch = "mov eax, _r11\nret\n" }
    elsif ($insn =~ /l.nop 0x0/) {}
    elsif ($insn =~ /l.j (.*)/) { if (exists $plt{$1}) { $f = $plt{$1} } else { $f = "L_$1" } $branch = "jmp $f\n"; }
    else { print ";???\n" }
    print $delay if ($delay);
    $delay = $branch;
}

print "section .data\n";
print "__r$_: dd 0\n" for (2..32);
print "strings:\n";
print <<EOS;
db 44h, 00h, 48h, 00h, 9ch, 21h, 00h, 04h, 62h, 61h, 64h, 20h, 63h, 68h, 61h, 72h,
db 00h, 43h, 61h, 6eh, 27h, 74h, 20h, 6fh, 70h, 65h, 6eh, 20h, 2fh, 64h, 65h, 76h,
db 2fh, 73h, 73h, 74h, 69h, 63h, 00h, 5bh, 1bh, 5bh, 33h, 32h, 3bh, 31h, 6dh, 2bh,
db 1bh, 5bh, 30h, 6dh, 5dh, 20h, 4fh, 53h, 20h, 72h, 65h, 74h, 75h, 72h, 6eh, 20h,
db 63h, 6fh, 64h, 65h, 20h, 3dh, 20h, 30h, 78h, 25h, 30h, 38h, 78h, 2ch, 20h, 54h,
db 41h, 20h, 72h, 65h, 74h, 75h, 72h, 6eh, 20h, 63h, 6fh, 64h, 65h, 20h, 3dh, 20h,
db 30h, 78h, 25h, 30h, 38h, 78h, 0ah, 00h, 5bh, 1bh, 5bh, 33h, 31h, 3bh, 31h, 6dh,
db 21h, 1bh, 5bh, 30h, 6dh, 5dh, 20h, 4fh, 53h, 20h, 72h, 65h, 74h, 75h, 72h, 6eh,
db 20h, 63h, 6fh, 64h, 65h, 20h, 3dh, 20h, 30h, 78h, 25h, 30h, 38h, 78h, 2ch, 20h,
db 54h, 41h, 20h, 72h, 65h, 74h, 75h, 72h, 6eh, 20h, 63h, 6fh, 64h, 65h, 20h, 3dh,
db 20h, 30h, 78h, 25h, 30h, 38h, 78h, 0ah, 00h, 2eh, 2fh, 54h, 41h, 2eh, 65h, 6ch,
db 66h, 2eh, 73h, 69h, 67h, 6eh, 65h, 64h, 00h, 43h, 61h, 6eh, 27h, 74h, 20h, 73h,
db 74h, 61h, 74h, 00h, 63h, 61h, 6eh, 27h, 74h, 20h, 6dh, 6dh, 61h, 70h, 00h, 5bh,
db 1bh, 5bh, 33h, 34h, 3bh, 31h, 6dh, 69h, 1bh, 5bh, 30h, 6dh, 5dh, 20h, 6ch, 6fh,
db 61h, 64h, 20h, 54h, 41h, 2eh, 65h, 6ch, 66h, 2eh, 73h, 69h, 67h, 6eh, 65h, 64h,
db 20h, 69h, 6eh, 20h, 54h, 72h, 75h, 73h, 74h, 65h, 64h, 4fh, 53h, 00h, 5bh, 1bh,
db 5bh, 33h, 34h, 3bh, 31h, 6dh, 69h, 1bh, 5bh, 30h, 6dh, 5dh, 20h, 53h, 65h, 6eh,
db 64h, 20h, 63h, 6fh, 6dh, 6dh, 61h, 6eh, 64h, 20h, 74h, 6fh, 20h, 54h, 72h, 75h,
db 73h, 74h, 65h, 64h, 20h, 41h, 70h, 70h, 20h, 43h, 4dh, 44h, 5fh, 47h, 45h, 54h,
db 5fh, 54h, 41h, 5fh, 56h, 45h, 52h, 53h, 49h, 4fh, 4eh, 00h, 72h, 65h, 74h, 72h,
db 65h, 69h, 76h, 65h, 64h, 20h, 76h, 65h, 72h, 73h, 69h, 6fh, 6eh, 20h, 3ah, 20h,
db 1bh, 5bh, 31h, 6dh, 25h, 73h, 1bh, 5bh, 30h, 6dh, 0ah, 00h, 5bh, 1bh, 5bh, 33h,
db 34h, 3bh, 31h, 6dh, 69h, 1bh, 5bh, 30h, 6dh, 5dh, 20h, 63h, 68h, 65h, 63h, 6bh,
db 20h, 70h, 61h, 73h, 73h, 77h, 6fh, 72h, 64h, 20h, 69h, 6eh, 20h, 54h, 45h, 45h,
db 00h, 43h, 61h, 6eh, 6eh, 6fh, 74h, 20h, 64h, 65h, 63h, 72h, 79h, 70h, 74h, 20h,
db 70h, 61h, 73h, 73h, 77h, 6fh, 72h, 64h, 20h, 62h, 6ch, 6fh, 62h, 00h, 1bh, 5bh,
db 33h, 31h, 3bh, 31h, 6dh, 42h, 61h, 64h, 20h, 70h, 61h, 73h, 73h, 77h, 6fh, 72h,
db 64h, 20h, 3ah, 28h, 1bh, 5bh, 30h, 6dh, 00h, 1bh, 5bh, 33h, 32h, 3bh, 31h, 6dh,
db 47h, 6fh, 6fh, 64h, 20h, 70h, 61h, 73h, 73h, 77h, 6fh, 72h, 64h, 20h, 21h, 1bh,
db 5bh, 30h, 6dh, 00h, 5bh, 1bh, 5bh, 33h, 34h, 3bh, 31h, 6dh, 69h, 1bh, 5bh, 30h,
db 6dh, 5dh, 20h, 55h, 6eh, 6ch, 6fh, 61h, 64h, 20h, 54h, 41h, 20h, 66h, 6fh, 72h,
db 6dh, 20h, 54h, 72h, 75h, 73h, 74h, 65h, 64h, 4fh, 53h, 00h, 5bh, 1bh, 5bh, 33h,
db 34h, 3bh, 31h, 6dh, 69h, 1bh, 5bh, 30h, 6dh, 5dh, 20h, 53h, 65h, 6eh, 64h, 20h,
db 63h, 6fh, 6dh, 6dh, 61h, 6eh, 64h, 20h, 74h, 6fh, 20h, 54h, 72h, 75h, 73h, 74h,
db 65h, 64h, 20h, 41h, 70h, 70h, 20h, 43h, 4dh, 44h, 5fh, 44h, 45h, 43h, 52h, 59h,
db 50h, 54h, 5fh, 42h, 4ch, 4fh, 43h, 4bh, 00h, 43h, 61h, 6eh, 27h, 74h, 20h, 6fh,
db 70h, 65h, 6eh, 20h, 25h, 73h, 20h, 66h, 6fh, 72h, 20h, 77h, 72h, 69h, 74h, 69h,
db 6eh, 67h, 0ah, 00h, 43h, 61h, 6eh, 27h, 74h, 20h, 72h, 65h, 61h, 64h, 20h, 49h,
db 56h, 00h, 42h, 61h, 64h, 20h, 62h, 6ch, 6fh, 63h, 6bh, 20h, 73h, 69h, 7ah, 65h,
db 00h, 75h, 73h, 61h, 67h, 65h, 3ah, 0ah, 25h, 73h, 20h, 5bh, 70h, 61h, 73h, 73h,
db 77h, 6fh, 72h, 64h, 5dh, 20h, 5bh, 65h, 6eh, 63h, 72h, 79h, 70h, 74h, 65h, 64h,
db 20h, 66h, 69h, 6ch, 65h, 5dh, 20h, 5bh, 64h, 65h, 73h, 74h, 69h, 6eh, 61h, 74h,
db 69h, 6fh, 6eh, 20h, 66h, 69h, 6ch, 65h, 5dh, 0ah, 00h, 42h, 61h, 64h, 20h, 70h,
db 61h, 73h, 73h, 77h, 6fh, 72h, 64h, 20h, 6ch, 65h, 6eh, 00h, 43h, 61h, 6eh, 27h,
db 74h, 20h, 64h, 65h, 63h, 6fh, 64h, 65h, 20h, 70h, 61h, 73h, 73h, 77h, 6fh, 72h,
db 64h, 00h, 43h, 61h, 6eh, 27h, 74h, 20h, 6ch, 6fh, 61h, 64h, 20h, 54h, 41h, 00h,
db 43h, 61h, 6eh, 27h, 74h, 20h, 6fh, 70h, 65h, 6eh, 20h, 25h, 73h, 20h, 66h, 6fh,
db 72h, 20h, 72h, 65h, 61h, 64h, 69h, 6eh, 67h, 0ah, 00h, 43h, 61h, 6eh, 27h, 74h,
db 20h, 72h, 65h, 61h, 64h, 20h, 65h, 6eh, 63h, 72h, 79h, 70h, 74h, 65h, 64h, 20h,
db 68h, 6dh, 61h, 63h, 20h, 66h, 72h, 6fh, 6dh, 20h, 25h, 73h, 0ah, 00h, 2fh, 6ch,
db 69h, 62h, 2fh, 6ch, 64h, 2dh, 6dh, 75h, 73h, 6ch, 2dh, 6fh, 72h, 31h, 6bh, 2eh,
db 73h, 6fh, 2eh, 31h, 00h, 00h, 00h, 00h, 01h, 1bh, 03h, 3bh, 00h, 00h, 00h, 48h,
EOS

