%sym = (
 "113f8" => "TEE_HMAC",
 "113e0" => "TEE_writekey",
 "113c8" => "TEE_write",
 "113d4" => "TEE_readkey",
 "113ec" => "TEE_AES_decrypt",
 "11590" => "start",
);

print "bits 32\n";
print "global $s\n" while ($addr, $s) = each %sym;
print "%define _ra [__ra]\n";
print "%define _a$_ [__a$_]\n" for (0..7);
print "%define _s$_ [__s$_]\n" for (0..7);
print "%define _t$_ [__t$_]\n" for (0..7);
print "section .text\n";

sub call {
    my $f = shift;
    return "push dword _a2\npush dword _a1\npush dword _a0\ncall $f\nadd esp, 12\n";
}

$ppp = $pp = $prev = "";

while (<>) {
    s/\t/ /;
    s/\s*<.*>$//;
    s/\s*[;#"].*$//;
    next unless /^   (11...):   ........ +(\S.+)/;
    $addr = $1;
    $insn = $2;
    print "\n;$addr $insn\n\n";
    print "L_$addr:\n";
    if (exists $sym{$addr}) { print "$sym{$addr}:\n" }
    if ($insn =~ /^li  ([ast]\d),(-?.+)/) { print "mov dword _$1, $2\n" }
    elsif ($insn =~ /ecall/) { print "sysenter\n" }
    elsif ($insn =~ /ret/) { print "ret\n" }
    elsif ($insn =~ /addi    sp,sp,(-?.+)/) { print "add esp, $1\n" }
    elsif ($insn =~ /addi    ([ast]\d),sp,(-?.+)/) { print "lea eax, [esp+($2)]\nmov _$1, eax\n" }
    elsif ($insn =~ /addi    ([ast]\d),\1,(-?.+)/) {
        $r = $1;
        $o = $2;
        if (int($o) < 0x3d0 && ($ppp.$pp.$prev) =~ /lui.*$r,0x10/) {
            if (int($o) == 0x54) {
                print "lea eax, [jmptbl]\nmov _$r, eax\n"
            } else {
                print "lea eax, [ori + $o]\nmov _$r, eax\n"
            }
        }
        else {
            print "mov eax, _$r\nadd eax, $o\nmov _$r, eax\n"
        }
    }
    elsif ($insn =~ /addi    ([ast]\d),([ast]\d),(-?.+)/) { print "mov eax, _$2\nadd eax, $3\nmov _$1, eax\n" }
    elsif ($insn =~ /xori    ([ast]\d),([ast]\d),(-?.+)/) { print "mov eax, _$2\nxor eax, $3\nmov _$1, eax\n" }
    elsif ($insn =~ /add ([ast]\d),sp,([ast]\d)/) { print "mov eax, esp\nadd eax, _$2\nmov _$1, eax\n" }
    elsif ($insn =~ /add ([ast]\d),([ast]\d),([ast]\d)/) { print "mov eax, _$2\nadd eax, _$3\nmov _$1, eax\n" }
    elsif ($insn =~ /xor ([ast]\d),([ast]\d),([ast]\d)/) { print "mov eax, _$2\nxor eax, _$3\nmov _$1, eax\n" }
    elsif ($insn =~ /sub ([ast]\d),([ast]\d),([ast]\d)/) { print "mov eax, _$2\nsub eax, _$3\nmov _$1, eax\n" }
    elsif ($insn =~ /bgtz    ([ast]\d),(.+)/) { print "cmp dword _$1, 0\njns L_$2\n" }
    elsif ($insn =~ /beqz    ([ast]\d),(.+)/) { print "cmp dword _$1, 0\njz L_$2\n" }
    elsif ($insn =~ /bnez    ([ast]\d),(.+)/) { print "cmp dword _$1, 0\njnz L_$2\n" }
    elsif ($insn =~ /bltu    ([ast]\d),([ast]\d),(.+)/) { print "mov eax, _$1\ncmp eax, _$2\njb L_$3\n" }
    elsif ($insn =~ /bleu    ([ast]\d),([ast]\d),(.+)/) { print "mov eax, _$1\ncmp eax, _$2\njbe L_$3\n" }
    elsif ($insn =~ /ble ([ast]\d),([ast]\d),(.+)/) { print "mov eax, _$1\ncmp eax, _$2\njle L_$3\n" }
    elsif ($insn =~ /beq ([ast]\d),([ast]\d),(.+)/) { print "mov eax, _$1\ncmp eax, _$2\njz L_$3\n" }
    elsif ($insn =~ /bne ([ast]\d),([ast]\d),(.+)/) { print "mov eax, _$1\ncmp eax, _$2\njnz L_$3\n" }
    elsif ($insn =~ /slli    ([ast]\d),([ast]\d),0x(\d+)/) { print "mov eax, _$2\nshl eax, 0$3h\nmov _$1, eax\n" }
    elsif ($insn =~ /srli    ([ast]\d),([ast]\d),0x(\d+)/) { print "mov eax, _$2\nshr eax, 0$3h\nmov _$1, eax\n" }
    elsif ($insn =~ /sll ([ast]\d),([ast]\d),([ast]\d)/) { print "mov eax, _$2\nmov cl, _$3\nshl eax, cl\nmov _$1, eax\n" }
    elsif ($insn =~ /srl ([ast]\d),([ast]\d),([ast]\d)/) { print "mov eax, _$2\nmov cl, _$3\nshr eax, cl\nmov _$1, eax\n" }
    elsif ($insn =~ /andi    ([ast]\d),([ast]\d),(-?.+)/) { print "mov eax, _$2\nand eax, $3\nmov _$1, eax\n" }
    elsif ($insn =~ /and ([ast]\d),([ast]\d),([ast]\d)/) { print "mov eax, _$2\nand eax, _$3\nmov _$1, eax\n" }
    elsif ($insn =~ /or  ([ast]\d),([ast]\d),([ast]\d)/) { print "mov eax, _$2\nor eax, _$3\nmov _$1, eax\n" }
    elsif ($insn =~ /neg ([ast]\d),([ast]\d)/) { print "mov eax, _$2\nneg eax\nmov _$1, eax\n" }
    elsif ($insn =~ /j   (.+)/) { print "jmp L_$1\n" }
    elsif ($insn =~ /jr  ([ast]\d)/) { print "mov eax, _$1\njmp eax\n" }
    elsif ($insn =~ /jal ra,(.+)/) { print call("L_$1") }
    elsif ($insn =~ /sb  ([ast]\d),(-?\d+)\(sp\)/) { print "mov al, _$1\nmov [esp+($2)], al\n" }
    elsif ($insn =~ /sb  ([ast]\d),(-?\d+)\(([ast]\d)\)/) { print "mov al, _$1\nmov ebx, _$3\nmov [ebx+($2)], al\n" }
    elsif ($insn =~ /sb  zero,(-?\d+)\(sp\)/) { print "mov byte [esp+($1)], 0\n" }
    elsif ($insn =~ /sb  zero,(-?\d+)\(([ast]\d)\)/) { print "mov ebx, _$2\nmov byte [ebx+($1)], 0\n" }
    elsif ($insn =~ /lbu ([ast]\d),(-?\d+)\(([ast]\d)\)/) { print "mov eax, _$3\nmovzx eax, byte [eax+($2)]\nmov _$1, eax\n" }
    elsif ($insn =~ /mv  ([ast]\d),sp/) { print "mov _$1, esp\n" }
    elsif ($insn =~ /mv  ([ast]\d),([ast]\d)/) { print "mov eax, _$2\nmov _$1, eax\n" }
    elsif ($insn =~ /lw  ([ast]\d),(-?\d+)\(sp\)/) { print "mov eax, [esp+($2)]\nmov _$1, eax\n" }
    elsif ($insn =~ /lw  ra,(-?\d+)\(sp\)/) { print "mov eax, [esp+($1)]\nmov _ra, eax\n" }
    elsif ($insn =~ /lw  ([ast]\d),(-?\d+)\(([ast]\d)\)/) { print "mov eax, _$3\nmov eax, [eax+($2)]\nmov _$1, eax\n" }
    elsif ($insn =~ /lui ([ast]\d),0x(.+)/) { print "mov dword _$1, (0$2h << 12)\n" }
    elsif ($insn =~ /lhu ([ast]\d),(-?\d+)\(([ast]\d)\)/) { print "mov eax, _$3\nmovzx eax, word [eax+($2)]\nmov _$1, eax\n" }
    elsif ($insn =~ /sw  ([ast]\d),(-?\d+)\(sp\)/) { print "mov eax, _$1\nmov [esp+($2)], eax\n" }
    elsif ($insn =~ /sw  ra,(-?\d+)\(sp\)/) { print "mov eax, _ra\nmov [esp+($1)], eax\n" }
    elsif ($insn =~ /sw  ([ast]\d),(-?\d+)\(([ast]\d)\)/) { print "mov eax, _$1\nmov ebx, _$3\nmov [ebx+($2)], eax\n" }
    elsif ($insn =~ /sw  zero,(-?\d+)\(([ast]\d)\)/) { print "mov ebx, _$2\nmov dword [ebx+($1)], 0\n" }
    elsif ($insn =~ /sltu    ([ast]\d),([ast]\d),([ast]\d)/)
                                            { print "mov eax, _$2\ncmp eax, _$3\nsetb al\nmovzx eax, al\nmov _$1, eax\n" }
    else { print "???\n" }
    $ppp = $pp;
    $pp = $prev;
    $prev = $insn;
}

print "section .data\n";
print "__ra: dd 0\n";
print "__a$_: dd 0\n" for (0..7);
print "__s$_: dd 0\n" for (0..7);
print "__t$_: dd 0\n" for (0..7);
print "jmptbl:\n";
print " dd L_11b98\n";
print " dd L_11b00\n";
print " dd L_11a08\n";
print " dd L_11644\n";
print " dd L_1192c\n";
print "section .original\n";
print "ori:\n";
print "incbin \"TA.elf.signed\"\n";
