#include <stdio.h>
#include <stdint.h>

typedef unsigned char byte;

byte code[1024];
char disas[1024];

int main(int argc, char *argv[])
{
    int vip, b0, b1, b2, opc, delta;
    uint32_t dw;
    FILE *in = fopen(argv[1], "rb");

    fread(code, 1, 320, in);

    fclose(in);

    disas[0] = 1;

    for (vip = 0; vip < 320;) {

        printf("%04x %02x ", vip, code[vip]);

        if (! disas[vip]) {
            printf("%02x\n", code[vip]);
            vip++;
            continue;
        }

        b0 = code[vip];
        b1 = code[vip+1];
        b2 = code[vip+2];
        vip += 3;
        switch (b0) {
        case 0x12:
            delta = b2 * 256 + b1;
            if (delta & 0x8000)
                delta = -(delta & 0x7fff);
            printf("jmp %04x\n", vip + delta);
            disas[vip + delta] = 1;
            goto no_disas_next;
            break;
        case 0x13:
            printf("X%d ^= X%d\n", b1 / 4, b2 / 4);
            break;
        case 0x2f:
            printf("X0 <- [1000 + 4 * ((X1 >> X2) & 3)]\n");            
            break;
        case 0x32:
            printf("X0 <- sse(X2, X1)\n");            
            break;
        case 0x33:
            printf("X%d == %02x\n", b1 / 4, b2);
            break;
        case 0x59:
            printf("[1020 + 4 * X1] <- X2\n");
            break;
        //case 0x47:
        //case 0x4d:
        //case 0x5b:
        //case 0x85:
        case 0x78:
        default:
            printf("X%d <- %02x\n", b1 / 4, b2);
            break;
        case 0x7c:
            printf("X0 <- 2 + [1f4b]\n");
            break;
        case 0xa1:
            delta = b2 * 256 + b1;
            if (delta & 0x8000)
                delta = -(delta & 0x7fff);
            printf("jtrue %04x\n", vip + delta);
            disas[vip + delta] = 1;
            break;
        case 0xaf:
            printf("X%d += X%d\n", b1 / 4, b2 / 4);
            break;
        case 0xbb:
            printf("X0 <- [1020 + 4 * X1]\n");
            break;
        case 0xdc:
            printf("exitvm (trigger ROP chain)\n");
            goto no_disas_next;
            break;
        case 0xfe:
            printf("X%d <- X%d\n", b1 / 4, b2 / 4);
            break;
        }
        disas[vip] = 1;
no_disas_next:;
    }
done:;

    return 0;
}
